%global _disable_ld_no_undefined 1
# Build with --debug (1) or --symbols (0)
%define debug           0
%define plugindir       %{_libdir}/%{name}%{major}/plugins
%define major           4
%define libname         %mklibname rnd %{major}
%define devname         %mklibname rnd -d
%define cloudlib        %mklibname rnd %{major}-cloud
%define guilib          %mklibname rnd %{major}-lib-gui
%define hidgtklib       %mklibname rnd %{major}-hid-gtk2-gdk
%define hidgtkgl        %mklibname rnd %{major}-hid-gtk2-gl
%define hidgtk4gl       %mklibname rnd %{major}-hid-gtk4-gl
%define gtklib          %mklibname rnd %{major}-lib-gtk
%define lesslib         %mklibname rnd %{major}-hid-lesstif
%define gllib           %mklibname rnd %{major}-lib-gl
%define pixmap          %mklibname rnd %{major}-pixmap

## NOTE This spec is auto-generated - only edit Version,
# Release, and svn revision here. See packaging.README.
#
# For new svn snapshots:
# Run ./mk-tar in SOURCES and note the svn revision in output.
# Uncomment (replace # with percent) and edit svn define to new revision.
#
# For new full releases:
# Update the tarball
# Replace percent sign with # in the 'define svn' line
# Edit the Version and Release

# Save this spec and close it.
# Now run ./mk-spec from SOURCES to totally re-create
# this spec file with any upstream changes.

# Comment out if not svn snapshot
@svn-revision@

@release@

Name:                   librnd
@version@
Release:                %mkrel %{?svn:0.%{svn}.}%{rel}
Summary:                @librnd4-summary@
Group:                  Sciences/Other
License:                GPLv2+
Url:                    http://www.repo.hu/projects/%{name}
Source0:                http://www.repo.hu/projects/%{name}/releases/%{name}%{?svn:-%{svn}}%{!?svn:-%{version}}.tar.gz
Source1:                mk-spec
Source2:                spec.tpl
Source3:                mk-tar
Source4:                packaging.README

BuildRequires:          fungw-devel
BuildRequires:          libgenht-devel
BuildRequires:          libstroke-devel
BuildRequires:          motif-devel
BuildRequires:          pkgconfig(gtk+-2.0)
BuildRequires:          pkgconfig(gtk4)
BuildRequires:          pkgconfig(gtkglext-1.0)
BuildRequires:          pkgconfig(gdlib)

%description
@librnd-librnd4-desc@

%package -n %{libname}
Summary:                @librnd4-summary@
Provides:               librnd%{major} = %{version}
%description -n %{libname}
@librnd-librnd4-desc@

%package -n %{devname}
Summary:                @dev-summary@
@dev-req@
Provides:               %{name}-devel = %{version}-%{release}
Provides:               %{name}%{major}-devel = %{version}-%{release}
%description -n %{devname}
@librnd-dev-desc@

%package -n %{cloudlib}
Summary:                @cloud-summary@
@cloud-req@
%description -n %{cloudlib}
@librnd-cloud-desc@

%package -n %{guilib}
Summary:                @lib-gui-summary@
@lib-gui-req@
%description -n %{guilib}
@librnd-lib-gui-desc@

%package -n %{hidgtklib}
Summary:                @hid-gtk2-gdk-summary@
@hid-gtk2-gdk-req@
Obsoletes:              pcb-rnd-hid-gtk2-gdk < 3.0.0
%description -n %{hidgtklib}
@librnd-hid-gtk2-gdk-desc@

%package -n %{hidgtkgl}
Summary:                @hid-gtk2-gl-summary@
@hid-gtk2-gl-req@
Obsoletes:              pcb-rnd-hid-gtk2-gl < 3.0.0
%description -n %{hidgtkgl}
@librnd-hid-gtk2-gl-desc@

%package -n %{gtklib}
Summary:                @lib-gtk-summary@
@lib-gtk-req@
Obsoletes:              pcb-rnd-lib-gtk < 3.0.0
%description -n %{gtklib}
@librnd-lib-gtk-desc@

%package -n %{hidgtk4gl}
Summary:                @hid-gtk4-gl-summary@
@hid-gtk4-gl-req@
%description -n %{hidgtk4gl}
@librnd-hid-gtk4-gl-desc@

%package -n %{lesslib}
Summary:                @hid-lesstif-summary@
@hid-lesstif-req@
Obsoletes:              pcb-rnd-hid-lesstif < 3.0.0
%description -n %{lesslib}
@librnd-hid-lesstif-desc@

%package -n %{gllib}
Summary:                @lib-gl-summary@%{hidgtkgl}
@lib-gl-req@
Obsoletes:              pcb-rnd-lib-gl < 3.0.0
%description -n %{gllib}
@librnd-lib-gl-desc@

%package -n  %{pixmap}
Summary:                @pixmap-summary@
@pixmap-req@
%description -n %{pixmap}
@librnd-pixmap-desc@

%package doc
Summary:                @doc-summary@
BuildArch:              noarch
%description doc
@librnd-doc-desc@

%prep
%autosetup -p1 -n %{name}%{?svn:-%{svn}}%{!?svn:-%{version}}

%build
%set_build_flags
export DEFAULT_CFLAGS="%{build_cflags}"
export DEFAULT_LDFLAGS="%{build_ldflags}"
./configure \
--CFLAGS="%{build_cflags} -Wno-incompatible-pointer-types -Wno-implicit-int -Wno-int-conversion -Wno-deprecated-declarations" \
--LDFLAGS="%{build_ldflags}" \
--libarchdir=%{_lib} \
@MAIN_CONFIGURE_OPTIONS@ \
%if %{debug} == 1
                prefix=%{_prefix} --debug
%else
                prefix=%{_prefix} --symbols
%endif

make

%check
make test

%install
%make_install

%files -n %{libname}
%{_libdir}/%{name}-*.so.%{major}{.,*}

%files -n %{devname}
@dev-files@
%{_libdir}/*.a

%files -n %{cloudlib}
@cloud-files@

%files -n %{guilib}
@lib-gui-files@

%files -n %{hidgtklib}
@hid-gtk2-gdk-files@

%files -n %{hidgtkgl}
@hid-gtk2-gl-files@

%files -n %{hidgtk4gl}
@hid-gtk4-gl-files@

%files -n %{gtklib}
@lib-gtk-files@

%files -n %{lesslib}
@hid-lesstif-files@

%files -n %{gllib}
@lib-gl-files@

%files -n %{pixmap}
@pixmap-files@

%files doc
%doc %{_docdir}/%{name}%{major}/
